diff -r e3c518c64971 trytond/modules/sale_opportunity/opportunity.py
--- a/trytond/modules/sale_opportunity/opportunity.py	Sun Sep 23 16:25:47 2012 +0200
+++ b/trytond/modules/sale_opportunity/opportunity.py	Mon Sep 24 20:36:42 2012 +0200
@@ -708,65 +644,44 @@
                         'company, '
                         'COUNT(1) AS number, '
                         'SUM(CASE WHEN state IN (' + ','.join("'%s'" % x
-                        for x in self._converted_state()) + ') '
+                        for x in cls._converted_state()) + ') '
                         'THEN 1 ELSE 0 END) AS converted, '
                         'SUM(CASE WHEN state IN (' + ','.join("'%s'" % x
-                        for x in self._lost_state()) + ') '
+                        for x in cls._lost_state()) + ') '
                         'THEN 1 ELSE 0 END) AS lost, '
                         'SUM(amount) AS amount, '
                         'SUM(CASE WHEN state IN (' + ','.join("'%s'" % x
-                        for x in self._converted_state()) + ') '
+                        for x in cls._converted_state()) + ') '
                         'THEN amount ELSE 0 END) AS converted_amount '
-                    'FROM "' + opportunity_obj._table + '" '
-                    'GROUP BY year, month, company) AS "' + self._table + '"',
+                    'FROM "' + Opportunity._table + '" '
+                    'GROUP BY year, month, company) AS "' + cls._table + '"',
                 [])
 
-    def get_conversion_rate(self, ids, name):
-        res = {}
-        for record in self.browse(ids):
-            if record.number:
-                res[record.id] = (float(record.converted)
-                    / record.number * 100.0)
-            else:
-                res[record.id] = 0.0
-        return res
+    def get_conversion_rate(self, name):
+        if self.number:
+            return float(self.converted) / self.number * 100.0
+        else:
+            return 0.0
 
-    def get_year_month(self, ids, name):
-        res = {}
-        for record in self.browse(ids):
-            res[record.id] = '%s-%s' % (record.year, int(record.month))
-        return res
+    def get_year_month(self, name):
+        return '%s-%s' % (self.year, int(self.month))
 
-    def get_currency(self, ids, name):
-        res = {}
-        for record in self.browse(ids):
-            res[record.id] = record.company.currency.id
-        return res
+    def get_currency(self, name):
+        return self.company.currency.id
 
-    def get_currency_digits(self, ids, name):
-        res = {}
-        for record in self.browse(ids):
-            res[record.id] = record.company.currency.digits
-        return res
+    def get_currency_digits(self, name):
+        return self.company.currency.digits
 
-    def get_conversion_amount_rate(self, ids, name):
-        res = {}
-        for record in self.browse(ids):
-            if record.amount:
-                res[record.id] = (float(record.converted_amount) /
-                        float(record.amount) * 100.0)
-            else:
-                res[record.id] = 0.0
-        return res
-
-SaleOpportunityMonthly()
+    def get_conversion_amount_rate(self, name):
+        if self.amount:
+            return float(self.converted_amount) / float(self.amount) * 100.0
+        else:
+            return 0.0
 
 
 class SaleOpportunityEmployeeMonthly(ModelSQL, ModelView):
     'Sale Opportunity per Employee per Month'
-    _name = 'sale.opportunity_employee_monthly'
-    _description = __doc__
-
+    __name__ = 'sale.opportunity_employee_monthly'
     year = fields.Char('Year')
     month = fields.Integer('Month')
     employee = fields.Many2One('company.employee', 'Employee')
@@ -788,22 +703,26 @@
     conversion_amount_rate = fields.Function(fields.Float(
         'Conversion Amount Rate', help='In %'), 'get_conversion_amount_rate')
 
-    def __init__(self):
-        super(SaleOpportunityEmployeeMonthly, self).__init__()
-        self._order.insert(0, ('year', 'DESC'))
-        self._order.insert(1, ('month', 'DESC'))
-        self._order.insert(2, ('employee', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(SaleOpportunityEmployeeMonthly, cls).__setup__()
+        cls._order.insert(0, ('year', 'DESC'))
+        cls._order.insert(1, ('month', 'DESC'))
+        cls._order.insert(2, ('employee', 'ASC'))
 
-    def _converted_state(self):
+    @staticmethod
+    def _converted_state():
         return ['converted']
 
-    def _lost_state(self):
+    @staticmethod
+    def _lost_state():
         return ['lost']
 
-    def table_query(self):
-        opportunity_obj = Pool().get('sale.opportunity')
-        type_id = FIELDS[self.id._type].sql_type(self.id)[0]
-        type_year = FIELDS[self.year._type].sql_type(self.year)[0]
+    @classmethod
+    def table_query(cls):
+        Opportunity = Pool().get('sale.opportunity')
+        type_id = FIELDS[cls.id._type].sql_type(cls.id)[0]
+        type_year = FIELDS[cls.year._type].sql_type(cls.year)[0]
         return ('SELECT CAST(id AS ' + type_id + ') AS id, create_uid, '
                     'create_date, write_uid, write_date, '
                     'CAST(year AS ' + type_year + ') AS year, month, '
@@ -823,49 +742,33 @@
                         'company, '
                         'COUNT(1) AS number, '
                         'SUM(CASE WHEN state IN (' + ','.join("'%s'" % x
-                        for x in self._converted_state()) + ') '
+                        for x in cls._converted_state()) + ') '
                         'THEN 1 ELSE 0 END) AS converted, '
                         'SUM(CASE WHEN state IN (' + ','.join("'%s'" % x
-                        for x in self._lost_state()) + ') '
+                        for x in cls._lost_state()) + ') '
                         'THEN 1 ELSE 0 END) AS lost, '
                         'SUM(amount) AS amount, '
                         'SUM(CASE WHEN state IN (' + ','.join("'%s'" % x
-                        for x in self._converted_state()) + ') '
+                        for x in cls._converted_state()) + ') '
                         'THEN amount ELSE 0 END) AS converted_amount '
-                    'FROM "' + opportunity_obj._table + '" '
+                    'FROM "' + Opportunity._table + '" '
                     'GROUP BY year, month, employee, company) '
-                'AS "' + self._table + '"', [])
+                'AS "' + cls._table + '"', [])
 
-    def get_conversion_rate(self, ids, name):
-        res = {}
-        for record in self.browse(ids):
-            if record.number:
-                res[record.id] = (float(record.converted)
-                    / record.number * 100.0)
-            else:
-                res[record.id] = 0.0
-        return res
+    def get_conversion_rate(self, name):
+        if self.number:
+            return float(self.converted) / self.number * 100.0
+        else:
+            return 0.0
 
-    def get_currency(self, ids, name):
-        res = {}
-        for record in self.browse(ids):
-            res[record.id] = record.company.currency.id
-        return res
+    def get_currency(self, name):
+        return self.company.currency.id
 
-    def get_currency_digits(self, ids, name):
-        res = {}
-        for record in self.browse(ids):
-            res[record.id] = record.company.currency.digits
-        return res
+    def get_currency_digits(self, name):
+        return self.company.currency.digits
 
-    def get_conversion_amount_rate(self, ids, name):
-        res = {}
-        for record in self.browse(ids):
-            if record.amount:
-                res[record.id] = (float(record.converted_amount) /
-                        float(record.amount) * 100.0)
-            else:
-                res[record.id] = 0.0
-        return res
-
-SaleOpportunityEmployeeMonthly()
+    def get_conversion_amount_rate(self, name):
+        if self.amount:
+            return float(self.converted_amount) / float(self.amount) * 100.0
+        else:
+            return 0.0
diff -r c062b0ae96c6 trytond/modules/sale_price_list/__init__.py
--- a/trytond/modules/sale_price_list/__init__.py	Fri Jun 08 19:34:24 2012 +0200
+++ b/trytond/modules/sale_price_list/__init__.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,6 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .party import *
 from .sale import *
 from .product import *
+
+
+def register():
+    Pool.register(
+        Party,
+        Sale,
+        SaleLine,
+        Product,
+        module='sale_price_list', type_='model')
diff -r c062b0ae96c6 trytond/modules/sale_price_list/party.py
--- a/trytond/modules/sale_price_list/party.py	Fri Jun 08 19:34:24 2012 +0200
+++ b/trytond/modules/sale_price_list/party.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,19 +1,20 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL, fields
-from trytond.pyson import Eval, Bool, Not, Get
+from trytond.model import fields
+from trytond.pyson import Eval
+from trytond.pool import PoolMeta
 
+__all__ = ['Party']
+__metaclass__ = PoolMeta
 
-class Party(ModelSQL, ModelView):
-    _name = 'party.party'
 
+class Party:
+    __name__ = 'party.party'
     sale_price_list = fields.Property(fields.Many2One('product.price_list',
             'Sale Price List',
             domain=[
-                ('company', '=', Get(Eval('context', {}), 'company')),
+                ('company', '=', Eval('context', {}).get('company')),
                 ],
             states={
-                'invisible': Not(Bool(Get(Eval('context', {}), 'company'))),
+                'invisible': ~Eval('context', {}).get('company'),
                 }))
-
-Party()
diff -r c062b0ae96c6 trytond/modules/sale_price_list/product.py
--- a/trytond/modules/sale_price_list/product.py	Fri Jun 08 19:34:24 2012 +0200
+++ b/trytond/modules/sale_price_list/product.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,25 +1,33 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level
 #of this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Product']
+__metaclass__ = PoolMeta
 
-class Product(ModelSQL, ModelView):
-    _name = 'product.product'
 
-    def get_sale_price(self, ids, quantity=0):
-        price_list_obj = Pool().get('product.price_list')
+class Product:
+    __name__ = 'product.product'
 
-        res = super(Product, self).get_sale_price(ids, quantity=quantity)
+    @classmethod
+    def get_sale_price(cls, products, quantity=0):
+        pool = Pool()
+        PriceList = pool.get('product.price_list')
+        Party = pool.get('party.party')
+        Uom = pool.get('product.uom')
+
+        prices = super(Product, cls).get_sale_price(products,
+            quantity=quantity)
         if (Transaction().context.get('price_list')
                 and Transaction().context.get('customer')):
-            for product in self.browse(ids):
-                res[product.id] = price_list_obj.compute(
-                        Transaction().context['price_list'],
-                        Transaction().context['customer'],
-                        product, res[product.id], quantity,
-                        Transaction().context.get('uom', product.default_uom))
-        return res
-
-Product()
+            price_list = PriceList(Transaction().context['price_list'])
+            customer = Party(Transaction().context['customer'])
+            context_uom = None
+            if Transaction().context.get('uom'):
+                context_uom = Uom(Transaction().context['uom'])
+            for product in products:
+                uom = context_uom or product.default_uom
+                prices[product.id] = price_list.compute(customer, product,
+                    product, quantity, uom)
+        return prices
diff -r c062b0ae96c6 trytond/modules/sale_price_list/sale.py
--- a/trytond/modules/sale_price_list/sale.py	Fri Jun 08 19:34:24 2012 +0200
+++ b/trytond/modules/sale_price_list/sale.py	Mon Sep 24 20:36:42 2012 +0200
@@ -3,12 +3,14 @@
 import copy
 from trytond.model import Model, fields
 from trytond.pyson import Eval, Not, Equal, Or, Bool
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Sale', 'SaleLine']
+__metaclass__ = PoolMeta
 
-class Sale(Model):
-    _name = 'sale.sale'
 
+class Sale:
+    __name__ = 'sale.sale'
     price_list = fields.Many2One('product.price_list', 'Price List',
         domain=[('company', '=', Eval('company'))],
         states={
@@ -17,64 +19,42 @@
             },
         depends=['state', 'company', 'lines'])
 
-    def __init__(self):
-        super(Sale, self).__init__()
-        self.party = copy.copy(self.party)
-        self.party.states = copy.copy(self.party.states)
-        self.party.states['readonly'] = Or(self.party.states['readonly'],
-                Bool(Eval('lines')))
-        if 'lines' not in self.party.depends:
-            self.party.depends = copy.copy(self.party.depends)
-            self.party.depends.append('lines')
-        self.lines = copy.copy(self.lines)
-        self.lines.states = copy.copy(self.lines.states)
-        self.lines.states['readonly'] = Or(self.lines.states['readonly'],
-                Not(Bool(Eval('party'))))
-        if 'party' not in self.lines.depends:
-            self.lines.depends = copy.copy(self.lines.depends)
-            self.lines.depends.append('party')
-        self._reset_columns()
+    @classmethod
+    def __setup__(cls):
+        super(Sale, cls).__setup__()
+        cls.party.states['readonly'] = (cls.party.states['readonly']
+            | Eval('lines'))
+        if 'lines' not in cls.party.depends:
+            cls.party.depends.append('lines')
+        cls.lines.states['readonly'] = (cls.lines.states['readonly']
+            | ~Eval('party'))
+        if 'party' not in cls.lines.depends:
+            cls.lines.depends.append('party')
 
-    def on_change_party(self, values):
-        party_obj = Pool().get('party.party')
-        price_list_obj = Pool().get('product.price_list')
-        res = super(Sale, self).on_change_party(values)
+    def on_change_party(self):
+        res = super(Sale, self).on_change_party()
         res['price_list'] = None
-        if values.get('party'):
-            party = party_obj.browse(values['party'])
-            res['price_list'] = party.sale_price_list and \
-                    party.sale_price_list.id or None
-        if res['price_list']:
-            res['price_list.rec_name'] = price_list_obj.browse(
-                    res['price_list']).rec_name
+        if self.party and self.party.sale_price_list:
+            res['price_list'] = self.party.sale_price_list.id
+            res['price_list.rec_name'] = self.party.sale_price_list.rec_name
         return res
 
-Sale()
 
+class SaleLine:
+    __name__ = 'sale.line'
 
-class SaleLine(Model):
-    _name = 'sale.line'
+    @classmethod
+    def __setup__(cls):
+        super(SaleLine, cls).__setup__()
+        if '_parent_sale.price_list' not in cls.quantity.on_change:
+            cls.quantity.on_change.append('_parent_sale.price_list')
+        if '_parent_sale.price_list' not in cls.unit.on_change:
+            cls.unit.on_change.append('_parent_sale.price_list')
+        if '_parent_sale.price_list' not in cls.product.on_change:
+            cls.product.on_change.append('_parent_sale.price_list')
 
-    def __init__(self):
-        super(SaleLine, self).__init__()
-        if '_parent_sale.price_list' not in self.quantity.on_change:
-            self.quantity = copy.copy(self.quantity)
-            self.quantity.on_change = copy.copy(self.quantity.on_change)
-            self.quantity.on_change.append('_parent_sale.price_list')
-        if '_parent_sale.price_list' not in self.unit.on_change:
-            self.unit = copy.copy(self.unit)
-            self.unit.on_change = copy.copy(self.unit.on_change)
-            self.unit.on_change.append('_parent_sale.price_list')
-        if '_parent_sale.price_list' not in self.product.on_change:
-            self.product = copy.copy(self.product)
-            self.product.on_change = copy.copy(self.product.on_change)
-            self.product.on_change.append('_parent_sale.price_list')
-        self._reset_columns()
-
-    def _get_context_sale_price(self, product, vals):
-        res = super(SaleLine, self)._get_context_sale_price(product, vals)
-        if vals.get('_parent_sale.price_list'):
-            res['price_list'] = vals['_parent_sale.price_list']
-        return res
-
-SaleLine()
+    def _get_context_sale_price(self):
+        context = super(SaleLine, self)._get_context_sale_price()
+        if self.sale and getattr(self.sale, 'price_list', None):
+            context['price_list'] = self.sale.price_list.id
+        return context
diff -r 2c8f8f0a1002 trytond/modules/sale_shipment_cost/__init__.py
--- a/trytond/modules/sale_shipment_cost/__init__.py	Tue Sep 11 15:28:58 2012 +0200
+++ b/trytond/modules/sale_shipment_cost/__init__.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,5 +1,15 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .sale import *
 from .stock import *
+
+
+def register():
+    Pool.register(
+        Configuration,
+        Sale,
+        SaleLine,
+        ShipmentOut,
+        module='sale_shipment_cost', type_='model')
